package net.cattaka.slidepuzzle.dto;

public class Score {
	private int id;
	private int solverType;
	private String answer;
	private int count;
	private int countL;
	private int countR;
	private int countU;
	private int countD;
	
	public Score() {
	}
	
	public void recalc() {
		count = 0;
		countL = 0;
		countR = 0;
		countU = 0;
		countD = 0;
		if (answer != null) {
			count = answer.length();
			for (int i=0;i<answer.length();i++) {
				switch (answer.charAt(i)) {
				case 'L':
					countL++;
					break;
				case 'R':
					countR++;
					break;
				case 'U':
					countU++;
					break;
				case 'D':
					countD++;
					break;
				default:
					break;
				}
			}
		}
	}
	
	public int getId() {
		return id;
	}
	public int getSolverType() {
		return solverType;
	}
	public String getAnswer() {
		return answer;
	}
	public void setId(int id) {
		this.id = id;
	}
	public void setSolverType(int solverType) {
		this.solverType = solverType;
	}
	public void setAnswer(String answer) {
		this.answer = answer;
	}
	public int getCount() {
		return count;
	}
	public void setCount(int count) {
		this.count = count;
	}
	public int getCountL() {
		return countL;
	}
	public void setCountL(int countL) {
		this.countL = countL;
	}
	public int getCountR() {
		return countR;
	}
	public void setCountR(int countR) {
		this.countR = countR;
	}
	public int getCountU() {
		return countU;
	}
	public void setCountU(int countU) {
		this.countU = countU;
	}
	public int getCountD() {
		return countD;
	}
	public void setCountD(int countD) {
		this.countD = countD;
	}
}
