package net.cattaka.slidepuzzle.test;

import net.cattaka.slidepuzzle.solver.SolveStageType2;
import net.cattaka.slidepuzzle.solver.Solver;
import net.cattaka.slidepuzzle.solver.World;
import net.cattaka.slidepuzzle.util.StringUtil;

public class SlideApp {
	public static void main(String[] args) {
		// byte wx = 3;
		// byte wy = 3;
		// byte[] tile = new byte[] {
		// 4, 0,-1,
		// 2, 1, 5,
		// -1, 8, 6
		// };
		// byte wx = 3;
		// byte wy = 4;
		// byte[] tile = new byte[] {
		// 5, 3, 6,
		// 2, 1, 9,
		// 0,-1, 11,
		// 4, 7,10
		// };
		// test1();
		// test2();
		//test3();
		//test4();
		run();
	}

	public static void run() {
//		 String dat ="2361=0478";
//		 byte wx = 3;
//		 byte wy = 3;

//		 String dat ="40=215=86";
//		 byte wx = 3;
//		 byte wy = 3;

//		 String dat ="5362190=B47A";
//		 byte wx = 3;
//		 byte wy = 4;

//		 String dat ="721095D=3H=6JK=SICXEGA4=LPQNMTVWR=ZU";
//		 byte wx = 6;
//		 byte wy = 6;

//		 String dat ="==439=785ADG0=FCMJOH=BNIK";
//		 byte wx = 5;
//		 byte wy = 5;

		 String dat ="23D4=1=C8E6B0A9";
		 byte wx = 5;
		 byte wy = 3;

//		String dat = "672I5M1389HC4AEBLD=FG0NOK";
//		byte wx = 5;
//		byte wy = 5;

//		String dat = "1245A9I7JN03HDO6GCKF8BLEM";
//		byte wx = 5;
//		byte wy = 5;
		
//		String dat = "358092=BDA6HL=4GI1JFCMNOK";
//		byte wx = 5;
//		byte wy = 5;
		
		World world = World.createWorld(dat, wx, wy);

		Solver solver = new Solver();
		solver.initialize(world, 1);
		World result = solver.solve(300, 1000000, 1000000);
		System.out.println(solver.getSolveStage());
		System.out.println(world.toString());
		System.out.println(result.toString());
		System.out.println(StringUtil.conv(result.getExPath()));
	}

	public static void test2() {
		{
			String dat = "2361=0478";
			byte wx = 3;
			byte wy = 3;

			World world = World.createWorld(dat, wx, wy);

			Solver solver = new Solver();
			solver.initialize(world, 2);
			solver.solve(200, 1000000, 1000000);
		}
	}

	public static void test3() {
		{
			String dat = "1245A9I7JN03HDO6GCKF8BLEM";
			byte wx = 5;
			byte wy = 5;

//			String dat = "1234567=9A=CDE=GHIJKLMN=PQRSTUVWX=Z0";
			//String dat ="721095D=3H=6JK=SICXEGA4=LPQNMTVWR=ZU";
//			byte wx = 6;
//			byte wy = 6;
			
			World world = World.createWorld(dat, wx, wy);
			SolveStageType2 solveStage = new SolveStageType2();
			solveStage.initialiez(world);
			System.out.println(solveStage);

			System.out.println(solveStage.calcScore(world));
		}
	}
	
	public static void test4() {
		{
			
//			String dat = "358092=BDA6HL=4GI1JFCMNOK";
//			byte wx = 5;
//			byte wy = 5;

			String dat = "1A3B458J26EZKF09LUD7GCIOP==MNTVWXYSH";
			byte wx = 6;
			byte wy = 6;

//			String dat = "1245A9I7JN03HDO6GCKF8BLEM";
//			byte wx = 5;
//			byte wy = 5;

//			String dat = "1234567=9A=CDE=GHIJKLMN=PQRSTUVWX=Z0";
			//String dat ="721095D=3H=6JK=SICXEGA4=LPQNMTVWR=ZU";
//			byte wx = 6;
//			byte wy = 6;
			
			World world = World.createWorld(dat, wx, wy);
			SolveStageType2 solveStage = new SolveStageType2();
			solveStage.initialiez(world);
			System.out.println(solveStage);

			System.out.println(solveStage.calcScore(world));
		}
	}
}