package net.cattaka.slidepuzzle.util;

import java.util.List;

import net.cattaka.slidepuzzle.SolverException;

public class SolverUtil {
	public static byte[] compact(byte[] in) {
		String str = StringUtil.conv(in);
		String tmp = null;
		while(true) {
			tmp = str.replaceAll("(UD)|(DU)|(LR)|(RL)", "");
			if ((tmp.length() == str.length())) {
				break;
			}
			str = tmp;
		} 
		byte[] result = new byte[tmp.length()];
		for (int i=0;i<tmp.length();i++) {
			result[i] = (byte) tmp.charAt(i);
		}
		return result;
	}
	public static void swapByte(byte[] bs, int wx, int wy, int x, int y, List<Byte> op) {
		for (byte b : op) {
			int fromIdx = x + wx*y;
			switch (b) {
			case 'U':
				y--;
				break;
			case 'D':
				y++;
				break;
			case 'L':
				x--;
				break;
			case 'R':
				x++;
				break;
			default:
				throw new SolverException("Bad input");
			}
			int toIdx = x + wx*y;
			byte t = bs[fromIdx];
			bs[fromIdx] = bs[toIdx];
			bs[toIdx] = t;
		}
	}
}
