SELECT
	B.SEQ,
	S.ANSWER
FROM (
	SELECT
		SEQ,
		CASE
			WHEN COUNT1 = MIN_COUNT THEN 1
			WHEN COUNT2 = MIN_COUNT THEN 2
			WHEN COUNT3 = MIN_COUNT THEN 3
		END SOLVER_TYPE
	FROM (
		SELECT
			C.SEQ,
			MIN(MIN(COALESCE(S1.COUNT,10000),COALESCE(S2.COUNT,10000)),COALESCE(S3.COUNT,10000)) MIN_COUNT,
			COALESCE(S1.COUNT,10000) COUNT1,
			COALESCE(S2.COUNT,0) COUNT2,
			COALESCE(S3.COUNT,0) COUNT3
		FROM COUNTER C
			LEFT JOIN SCORE S1 ON C.SEQ = S1.ID AND S1.SOLVER_TYPE=1
			LEFT JOIN SCORE S2 ON C.SEQ = S2.ID AND S2.SOLVER_TYPE=2
			LEFT JOIN SCORE S3 ON C.SEQ = S3.ID AND S3.SOLVER_TYPE=3
		ORDER BY C.SEQ
	)
) B
LEFT JOIN SCORE S WHERE S.ID=B.SEQ AND S.SOLVER_TYPE=B.SOLVER_TYPE
ORDER BY B.SEQ

