package net.cattaka.slidepuzzle.solver;

import java.util.Map;
import java.util.Set;

public interface ISolveStage {
	public void initialiez(World world);

	public int calcScore(World world);

	public int getMinScore();
	public int getMaxScore();
	
	public int getSolverType();
	
	public boolean isCutByScore();
	public boolean isStepByScore();
	public boolean isStepPosition(int x, int y);
	
	public void excludeUncertainlyCurrentSet(Set<World> worlds, int limit);
	public void excludeUncertainlyHistoryMap(Map<World,World> worlds, int limit);
}
